<?php

    $web_path = '/photos/rotate/';
    $fs_path = '/var/www/photos/rotate/';
    $captions = $fs_path . '.captions';
    include ($captions); 
    if (isset ( $rotating_images ))
    {
	// max img_no
	$max_img_no = count($rotating_images)-1;
	
	// we need a numerically indexed array for rotation
	$i = 0;
	foreach ($rotating_images as $k => $v) {
	    $images[$i]['file'] = $k;
	    $images[$i]['caption'] = $v;
	    $i++;
	}
	
	// validate img_no (must be an integer within [0,$max_img_no])
	if (isset($_GET['img_no']) 
		&& is_numeric($_GET['img_no']) 
		&& intval($_GET['img_no']) >= 0 
		&& intval($_GET['img_no']) <= $max_img_no ){
	    $img_no = intval($_GET['img_no']);
	}else{
	    // start with random image (first page load or invalid value from GET)
	    $img_no = rand(0,count($rotating_images)-1);
	}

	// image and caption to be displayed
	$img = $images[$img_no]['file'];
        $caption = $images[$img_no]['caption'];
	
	// img_no values for 'prev' and 'next' buttons
	$img_no_next = ( $img_no == $max_img_no ? 0 : $img_no+1 );
	$img_no_prev = ( $img_no == 0 ? $max_img_no : $img_no-1 );
	
	// Now build a table with either two rows or two columns 
	// depending on the aspect of the image file
        $output = "<table width=\"415\" border=\"0\">\n";
        list($image_width,$image_height)=getimagesize("$fs_path$img");
        $max_height = 315;
        $max_width = 415;
        $scale = min($max_height/$image_height, $max_width/$image_width);
        $display_height = floor($scale * $image_height);
        $display_width = floor($scale * $image_width);

        if ($image_width >= $image_height) {
            // two rows, one column
    	    $output .= "<tr>\n";
    	    $output .= "<td><img src=\"".$web_path.$img."\" height=\"".$display_height."\" alt=\"".$caption."\" /></td>\n</tr>\n";
    	    $output .= "<tr>\n<td>".$caption."</td>\n</tr>\n";
	}else{
	    // two columns, one row
    	    $output .= "<tr>\n";
    	    $output .= "<td><img src=\"".$web_path.$img."\" height=\"".$display_height."\" alt=\"".$caption."\" /></td>\n";
    	    $output .= "<td>".$caption."</td>\n</tr>\n";
	}
	$output .= "</table>\n";

	// rotator panel: Prev, N_of_M, Next
	$output .= '<div id="rotator">';
	$output .= '<table><tr>';
	$output .= '<td><img src="/images/go-prev.png" id="rotprev" alt="Prv" width="20px" height="15px" '.
		    'onMouseOver="rotprevMouseOver()" '.
		    'onMouseOut="rotprevMouseOut()" '.
		    'onClick="ajaxNextImage('.$img_no_prev.')" /></td><td style="text-align:center">';
	$output .=  $img_no+1 . ' of ' . count($rotating_images);
	$output .= '</td><td><img src="/images/go-next.png" id="rotnext" alt="Nxt" width="20px" height="15px" '.
		    'onMouseOver="rotnextMouseOver()" '.
		    'onMouseOut="rotnextMouseOut()" '.
		    'onClick="ajaxNextImage('.$img_no_next.')" /></td>';
	$output .= '</tr></table>';
	$output .= '</div>';

	echo $output;
    } else {
	echo "Error: Captions' file in $web_path doesn't seem to exist.";
    }


?>
